5.3 Bedingungen

# Bedingungen

Was du dir wahrscheinlich wünschen wirst, ist nicht einfach nur eine zufällige Note zu spielen (siehe auch den letzten Abschnitt über Zufälligkeit), sondern auch eine zufällige Entscheidung treffen zu können, und je nachdem wie diese ausfällt, den einen oder den anderen Code ablaufen zu lassen. Zum Beispiel könnte es sein, dass du einer Zufälligkeit folgend entweder eine Trommel oder ein Becken abspielen möchtest. Das können wir mit einem `if`-Ausdruck erreichen.

## Eine Münze werfen

Werfen wir also ein Münze: Bei Kopf, spiele eine Trommel, bei Zahl, ein Becken. Das ist leicht. Wir können den Münzwurf mit unserer `one_in`-Funktion nachbilden (eingeführt im Kapitel über Zufälligkeit), indem wir eine Wahrscheinlichkeit von 1 aus 2 angeben: `one_in(2)`. Das Ergebnis dieser Berechnung können wir nutzen, um zwischen zwei Code-Abschnitten auszuwählen, entweder den Code, um die Trommel zu spielen oder den Code, um das Becken zu spielen:

```
loop do
  if one_in(2)
    sample :drum_heavy_kick
  else
    sample :drum_cymbal_closed
  end
  
  sleep 0.5
  
end
```

Merke dir, dass `if`-Anweisungen drei Teile haben:

* Die Frage, die gestellt wird
* Die Auswahl von Programm-Code, der laufen soll (wenn die Antwort auf die Frage ein Ja ist)
* Die zweite Auswahl von Programm-Code, der laufen soll (wenn die Antwort auf die Frage ein Nein ist)

In Programmiersprachen steht typischerweise für das Ja der Ausdruck `true` und für das Nein der Ausdruck `false`. Also müssen wir eine Frage finden, auf die wir eine Antwort erhalten, die entweder `true` (wahr) oder `false` (falsch) ist. Das ist genau das, was `one_in` tut.

Beachte, wie hier die erste Wahl zwischen dem `if` und dem `else` und die zweite Wahl zwischen dem `else` und dem `end` eingeschlossen wird. So wie bei den do/end-Blöcken kannst du beliebig viele Codezeilen an beiden Stellen einfügen. Zum Beispiel:

```
loop do
  if one_in(2)
    sample :drum_heavy_kick
    sleep 0.5
  else
    sample :drum_cymbal_closed
    sleep 0.25
  end
  
end
```

Dieses Mal lassen wir den Code unterschiedlich lange schlafen, je nachdem welche Auswahl getroffen wird.


## Einfaches if

Manchmal möchtest du wahlweise nur eine Code-Zeile ausführen. Das ist möglich, indem du ein `if` setzt und dahinter die Frage an das Ende, zum Beispiel:

```
use_synth :dsaw
loop do
  play 50, amp: 0.3, release: 2
  play 53, amp: 0.3, release: 2 if one_in(2)
  play 57, amp: 0.3, release: 2 if one_in(3)
  play 60, amp: 0.3, release: 2 if one_in(4)
  sleep 1.5
end
```

Dieses Beispiel spielt Akkorde, bestehend aus verschiedenen Noten, wobei die Chance gespielt zu werden für die einzelnen Noten jeweils eine andere Wahrscheinlichkeit hat.
