7.3 Gleitende Parameter

# Gleitende Parameter

Während du die Synth- und Effekt-Optionen erforscht hast, ist dir vielleicht aufgefallen, dass einige von ihnen auf `_slide` enden. Vielleicht hast du sogar ausprobiert sie aufzurufen und keinen Effekt bemerkt. Das liegt daran, dass dies keine normalen Parameter sind, sie sind besondere Opts, die nur dann funktionieren, wenn du Synths steuerst, wie im letzten Abschnitt beschrieben.

Schau dir das folgende Beispiel an:

```
s = play 60, release: 5
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Hier kannst du hören, wie sich die Tonhöhe des Synth unmittelbar bei jedem Aufruf von `control` ändert. Vielleicht möchtest du aber, dass die Tonhöhe sich gleitend zwischen den Aufrufen verändert. Wenn wir die Opt `note:` verwenden, müssen wir, um gleitende Übergänge zu erhalten, den `note_slide:`-Parameter des Synth setzen:

```
s = play 60, release: 5, note_slide: 1
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Nun hören wir, wie die Noten zwischen den `control`-Aufrufen gezogen werden. Hört sich gut an, oder? Mit einer kürzeren Dauer wie beispielsweise `note_slide: 0,2` kannst du den Übergang beschleunigen, oder ihn mit einer längeren Slide-Dauer verlangsamen.

Jeder steuerbare Parameter hat einen entsprechenden `_slide`-Parameter, mit dem du spielen kannst.

## Gleiten ist klebrig

Nachdem du einmal einen `_slide` Parameter auf einem laufenden Synth gesetzt hast, wird er erinnert - und er wird jedes mal genutzt, wenn du den dazu gehörenden Parameter nutzt. Um das Gleiten zu stoppen, musst du den `_slide` Wert vor dem nächsten `control`-Aufruf auf 0 setzen.

## Gleitende Effekt-Parameter

Es ist ebenso möglich, Effekt-Opts gleiten zu lassen:

```
with_fx :wobble, phase: 1, phase_slide: 5 do |e|
  use_synth :dsaw
  play 50, release: 5
  control e, phase: 0.025
end
```

Und jetzt hab Spaß damit die Dinge ein wenig herumgleiten zu lassen - für weiche Übergänge und Steuerung der Abläufe ...
