1.2 Explorando la interfaz

# La interfaz de Sonic Pi

Sonic Pi tiene una interfaz sencilla para programar música. Echemos un vistazo a esto.

![La Interfaz de Sonic Pi](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Controles de Ejecución
* *B* - Controles de edición
* *C* - Información y Ayuda
* *D* - Editor de código
* *E* - Panel de Preferencias
* *F* - Visor de Registros
* *G* - Sistema de Ayuda
* *H* - Visor de Registros
* *I* - Visor de Cue

## A. Controles de Ejecución

Estos botones rosados son los principales controles para comenzar y parar sonidos. El botón de *Ejecutar* sirve para iniciar la ejecución del código y *Parar* para parar todo código en Ejecución, *Guardar* para guardar el código a un archivo externo y *Grabar* para crear una grabación (archivo WAV) de los sonidos ejecutándose.

## B. Controles de edición

Estos botones naranjas te permiten manipular el editor de código. Los botones de *Tamaño +* y Tamaño -* te permiten aumentar y disminuir el tamaño del texto.

## C. Información y Ayuda

Estos botones azules te dan acceso a información, ayuda y preferencias. El botón *Info* abre la ventana informativa, la cual contiene información del propio programa Sonic Pi - el equipo base, historia, contribuyentes y la comunidad. El botón de *Ayuda* muestra u oculta el sistema de ayuda y el botón *Preferencias* activa la ventana de preferencias, que te permite controlar algunos parámetros básicos del sistema.

## D. Editor de código

Esta es el área donde escribirás tu código y compondrás/ejecutarás música. Es un sencillo editor de texto donde puedes escribir, borrar, cortar, pegar, etc. Piensa que es una versión simplificada de Word o Google Docs. El editor colorea las palabras automáticamente, basado en su significado para el código. Al principio, esto puede parecer extraño, pero pronto lo encontrarás muy útil. Por ejemplo, sabrás que algo es un número, porque es de color azul.

## E. Panel de Preferencias

Sonic Pi permite cambiar ciertos parámetros accesibles a través del botón *preferencias* . Este botón cambia la visibilidad del panel de preferencias, el cual incluye un número de opciones a ser cambiadas. Por ejemplo forzar el modo mono, invertir el estéreo, cambiar a vista/no vista de la bitácora, mando de volumen y un selector de audio para la Raspberry Pi.

## F. Visor de Log

Cuando ejecutas un código, el visualizador del log muestra información de lo que está haciendo el programa. Predeterminado está el que veas un mensaje por cada sonido que crees con el tiempo exacto al que fue disparado el sonido. Esto es muy útil para depurar código y entender qué es lo que está haciendo.

## G. Sistema de ayuda

Finalmente, una de las partes más importantes de la interfaz de Sonic Pi es el sistema de ayuda que aparece en la parte baja de la ventana. Esta puede ser activada o desactivada al apretar el botón azul «Ayuda». El sistema de ayuda contiene información de todos los aspectos de Sonic Pi incluído este tutorial, listado de sintetizadores disponibles, muestras (samples), ejemplos, efectos y una lista de todas las funciones que Sonic Pi provee para codificar música.

## H. Visor Osciloscópico

El visor de alcance le permite ver el sonido que esta escuchando. Usted puede ver fácilmente que la onda de la sierra parece una sierra y que el pitido básico es una curva de onda senoidal. También puede ver la diferencia entre sonidos fuertes y silenciosos por el tamaño de las líneas. Hay 3 alcances para jugar - el defecto es un alcance combinado para los canales izquierdos y derechos, hay un alcance estéreo que dibuja un alcance separado para cada canal. Finalmente hay un alcance de curva Lissajous que mostrará la relación de fase entre los canales izquierdo y derecho y le permitirá dibujar imágenes bonitas con sonido (https://en.wikipedia.org/wiki/Lissajous_curve).

## I. Visor de Cue

Todos los eventos internos y externos (llamados cues en Sonic PI) son registrados automáticamente en el Visor Cue. Por ejemplo si tiene un controlador MIDI conectado y presione uno de sus botones, verá un nuevo evento cue en el Visor Cue que le dará el nombre del controlador y del botó que presionó. Una vez haya dominado lo básico de crear y producir sonidos, querrá registrar sonidos o selecciones completas de sonidos basado en eventos como esos. Un evento cue es solo una indicación de que ha ocurrido algo. Por ejemplo, cada vez que un ciclo vivo da la vuelta, envía un evento cue que es registrado en el Visor de Cue. También los eventos externos como mensajes MIDI de equipo MIDI conectado y mensajes OSC de otros programas o computadores se presentan en el Visor Cue. También es posible generar directamente eventos cue usando la función `cue`. Cualquier cosa que aparezca en el Visor Cue puede usarse para iniciar que algo ocurra. Esto se cubre en más detalle en la Secciones 10 a 12 de este tutorial.
