3.5 Sampleos parciales

# Muestras parciales

Esta sección concluirá nuestra exploración del reproductor de muestras de Sonic Pi. Hagamos una rápida recapitulación. Hasta ahora hemos visto cómo podemos disparar muestras:

```
sample :loop_amen
```

A continuación, analizamos cómo podemos cambiar la velocidad de las muestras, por ejemplo, reproduciéndolas a media velocidad:

```
sample :loop_amen, rate: 0.5
```

Después miramos como podíamos aparecer un pequeño sampleo (hagámoslo a media velocidad):

```
sample :loop_amen, rate: 0.5, attack: 1
```

También miramos como podíamos usar el comienzo de un sampleo percusivamente al darle a `mantenido:` un valor explícito y ajustar ambos el ataque y el release con valores cortos:

```
sample :loop_amen, rate: 2, attack: 0.01, sustain: 0, release: 0.35
```

Sin embargo, ¿no sería bueno que no tuviéramos que empezar siempre por el principio de la muestra? ¿No sería bueno que no tuviéramos que terminar siempre al final de la muestra?

## Escogiendo un punto de inicio

Es posible elegir un punto de inicio arbitrario en el sampleo con un valor entre 0 y 1, donde 0 es el punto de comienzo, 1 es el punto de final y 0.5 es la mitad del sampleo. Intentemos ejecutar únicamente la última mitad del sampleo de amen break:

```
sample :loop_amen, start: 0.5
```

¿Qué tal escuchar el último cuarto del sample?:

```
sample :loop_amen, start: 0.75
```

## Escogiendo punto de termino

Igualmente, es posible escoger un punto de termino arbitrario en el sample, con un valor entre 0 y 1. Vamos a terminar el amen break a la mitad:

```
sample :loop_amen, finish: 0.5
```

## Especificando el comienzo y el final

Por supuesto que podemos combinar dos para tocar segmentos del archivo de audio arbitrariamente. ¿Qué tal solo una pequeña sección en el medio?

```
sample :loop_amen, start: 0.4, finish: 0.6
```

¿Qué pasa si elegimos comenzar en una posición después del final?


```
sample :loop_amen, start: 0.6, finish: 0.4
```

¡Genial! ¡Lo reproduce al revés!

## Combinando con velocidad

Podemos combinar esta nueva herramienta para tocar segmentos arbitrarios de audio con nuestro amigo `rate:`. Por ejemplo, podemos tocar una pequeña sección al medio de amen break muy lentamente:

```
sample :loop_amen, start: 0.5, finish: 0.7, rate: 0.2
```

## Combinando con envolventes

Finalmente, podemos combinar todo esto con nuestras envolventes ADSR para producir resultados interesantes:

```
sample :loop_amen, start: 0.5, finish: 0.8, rate: -0.2, attack: 0.3, release: 1
```

Ahora vete y juega con sampleos y todas estas divertidas herramientas...
