3.6 Échantillons externes

# Échantillons externes

Bien que les échantillons fournis en interne puissent vous motiver et vous faire démarrer rapidement, vous pourriez souhaiter d'expérimenter d'autres sons pré-enregistrés dans votre musique. Sonic Pi supporte complètement cela. En premier lieu toutefois ayons une rapide discussion sur la portabilité de votre œuvre.

## Portabilité

Quand vous composez votre morceau uniquement avec des synthés et des échantillons internes, le code est tout ce dont vous avez besoin pour reproduire fidèlement votre musique. Pensez à cela un instant – c'est génial ! Un simple morceau de texte que vous pouvez envoyer par courriel ou coller dans un [Gist](https://gist.github.com) représente tout ce dont vous avez besoin pour reproduire vos sons. Cela le rend *vraiment facile à partager* avec vos amis puisqu'ils ont juste besoin de se procurer le code.

Toutefois, si vous commencez à utiliser vos propres échantillons pré-enregistrés, vous perdez cette portabilité. C'est parce que pour reproduire votre musique les autres ont besoin non seulement de votre code, mais aussi de vos échantillons. Ceci limite la capacité pour les autres de manipuler, triturer et expérimenter avec votre oeuvre. Bien entendu, ceci ne doit pas vous empêcher d'utiliser vos propres échantillons, c'est juste quelque chose à prendre en compte.

## Échantillons locaux

Alors comment faire pour jouer n'importe quel fichier WAV, AIFF, OGG, OGA ou FLAC sur votre ordinateur ? Tout ce dont vous avez besoin est de passer le chemin de ce fichier à `sample` :

```
# Raspberry Pi, Mac, Linux
sample "/Users/sam/Desktop/my-sound.wav"
# Windows
sample "C:/Users/sam/Desktop/my-sound.wav"
```

Sonic Pi chargera automatiquement et jouera votre échantillon. Vous pouvez aussi passer tous les paramètres que vous avez l'habitude de passer à `sample` :

```
# Raspberry Pi, Mac, Linux
sample "/Users/sam/Desktop/my-sound.wav", rate: 0.5, amp: 0.3
# Windows
sample "C:/Users/sam/Desktop/my-sound.wav", rate: 0.5, amp: 0.3
```

