7.3 Parametri scorrevoli

# Parametri scorrevoli

Esplorando i parametri dei synth e degli effetti avrai notato come alcuni di essi terminano con `_slide`. Magari hai anche provato a richiamarli ma senza alcun risultato. Questo succede perché, a differenza dei normali parametri, funzionano solo quando controlli il synth come discusso nella sezione precedente.

Considera il seguente esempio:

```
s = play 60, release: 5
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Puoi sentire il pitch del sintetizzatore cambiare a ogni chiamata di `control`. Può capire, però, che ci sia uno slide tra i vari cambiamenti. Siccome stiamo controllando il parametro `note:`, per aggiungere lo scorrimento, dobbiamo impostare il parametro `note_slide`:

```
s = play 60, release: 5, note_slide: 1
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Ora sentiamo che la nota viene "piegata" ogni volta che `control` viene richiamato. Suona bene, vero? Possiamo velocizzare lo slide utilizzando un tempo inferiore come `note_slide: 0.2` o rallentarlo usando valori più lunghi.

Ogni parametro che puoi controllare, ha un parametro corrispettivo `_slide` con cui puoi giocare.

## Lo scorrimento è delicato

Ogni volta che imposti un parametro `_slide` su un synth in riproduzione, verrà ricordato e usato ogni volta che scorri il parametro corrispondente. Per fermare lo slide, devi impostare il valore di `_slide`a 0 prima del successivo `control`.

## Parametri di scorrimento degli effetti

È possibile controllare lo scorrimento degli effetti:

```
with_fx :wobble, phase: 1, phase_slide: 5 do |e|
  use_synth :dsaw
  play 50, release: 5
  control e, phase: 0.025
end
```

Ora possiamo divertirci utilizzando lo scorrimento per creare transizioni più fluide...
