1.2 インタフェースの探索

# Sonic Pi のインタフェース

Sonic Piは、音楽をコーディング（記述）するためのとてもシンプルなインタフェース（操作画面）を持っています。ちょっと見てみましょう。

![Sonic Piのインターフェイス](../../../etc/doc/images/tutorial/GUI.png)


* *A* - 演奏の操作
* *B* - 編集の操作
* *C* - 情報とヘルプ
* *D* - コードエディタ
* *E* - 設定画面
* *F* - ログビューア
* *G* - ヘルプシステム
* *H* - スコープビューア
* *I* - キュービューア

## A. 演奏の操作

ここにあるピンクのボタンで、音を再生したり停止するための主要な操作ができます。*Run*ボタンは編集画面内のコードを実行します。*Stop*ボタンですべてのコードの動作を停止します。*Save*ボタンは外部ファイルにコードを保存し、*Record*ボタンは演奏中の音を（WAVファイルに）録音します。

## B. 編集の操作

ここにあるピンクのボタンでコードエディタの設定を変えられます。*Size +* と *Size -* ボタンでコードエディタの文字を大きくしたり小さくしたりできます。

## C. 情報とヘルプ

これらの青いボタンで、情報、ヘルプや設定にアクセスします。*Info*ボタンは、概要、コア、協力者、コミュニティ、ライセンス、ヒストリーといったSonic Pi自体についての情報を画面に表示します。*Help*ボタンは*G*のヘルプシステム表示を切り替えます。また*Prefs*ボタンは基本的なシステムを操作するための設定画面の表示を切り替えます。

## D. コードエディタ

ここは音楽を作曲/演奏したりするためのコードを書く領域です。コードを書いたり、消したり、切り取り、貼り付けなどを行うためのシンプルな編集画面です。Google DocsやWordの基本版だと思ってください。編集画面ではコードの意味合いに応じて自動で色つけします。はじめは変わっていると思うかもしれませんが、とても使いやすくなるはずです。例えば、数値は青色で示されます。

## E. 設定画面

Sonic Piには変更可能な設定がたくさんあり、*Prefs*ボタンを切り替えることでアクセスできます。このボタンにより、環境設定パネルの表示/非表示を切り替えることができます。設定の例としては、モノラルモードへの変更や、ステレオ反転、ログ出力の切り替え、さらにRaspberry Piのボリュームスライダーやオーディオセレクターなどがあります。

## F. ログビューア

コードを実行させた時、ログ画面にはプログラムがどうなっているかについての情報が表示されます。デフォルトでは、正確な再生時間を毎音ごとにメッセージとして見ることができます。コードのデバッグ（欠陥を取り除く作業）に利用でき、コードが何をしているかを理解することにも役立ちます。

## G. ヘルプシステム

最後は、Sonic Piインタフェースのもっとも重要な部分の1つである、画面の下にあるヘルプシステムです。青い*Help*ボタンによって表示/非表示を切り替えることができます。ヘルプシステムは、ヘルプと情報を含んでいます。このチュートリアル、入手できるシンセのリスト、サンプルや実例、エフェクトのリスト、そして音楽をコーディングするために備えているSonic Piの全機能のリストといった、Sonic Piの全てについてのヘルプと情報があります。

## H. スコープビューア

スコープビューアは、あなたの聞いている音を見ることを可能にします。ノコギリ波がのこぎりのようだったり、単純なビープ音が正弦波であることを簡単に見ることが出来ます。また、うるさい音と静かな音の違いを線の大きさで見ることも可能です。Sonic Piには、3つのスコープがあります。デフォルトは左右のチャネルを混ぜあわせたモノラルスコープです。左右のチャネルを別々のスコープで描画するステレオスコープがあります。最後に、左右のチャネルの位相の関係を描画する[リサジュース曲線](https://ja.wikipedia.org/wiki/%E3%83%AA%E3%82%B5%E3%82%B8%E3%83%A5%E3%83%BC%E5%9B%B3%E5%BD%A2)スコープがあります。

## F. キュービューア

すべての内部および外部のイベント（Sonic Piではキューと呼ばれます）は、キュービューアーに自動的に記録されます。たとえば、MIDIコントローラーが接続された状態でボタンを押すと、コントローラーの名前からなる新しいキューイベントがキュービューアーに表示されます。サウンドの作成と生成の基本をマスターすると、このようなイベントに基づいて、サウンドまたはサウンドのセクション全体をキューに入れたいと思うようになります。キューイベントは、何かが起こったことを示すだけです。たとえば、ライブループが実行されるたびに、キュービューアに記録されているキューイベントが送信されます。また、接続されているMIDI機器からのMIDIメッセージや他のプログラムやコンピューターからのOSCメッセージなどの外部イベントもキュービューアーに表示されます。 `cue`関数を使用してキューイベントを直接生成することもできます。キュービューアに表示されるものはすべて、何かが発生するようにトリガーするために使用できます。これについては、このチュートリアルのセクション10〜12で詳しく説明しています。
