2.3 シンセの切り替え

# シンセの切り替え

これまで、ビープ音を鳴らして楽しんできました。けれども、もしかするとあなたはこのベーシックなビープ音に退屈し始めているかも知れません。これがSonic Piが提供してくれるサウンドの全てなのでしょうか？ もちろん、ビープ音だけではなくて、もっと他にもたくさんのライブコーディングがありますよね？ はい、あります。この章ではSonic Piが作り出すワクワクさせる音を試してみましょう。

## シンセ

Sonic Piは、シンセサイザーの略であるシンセと呼ばれる楽器の機能を持っています。サンプルがすでに録音された音であるのに対して、シンセはあなたがそれをコントロールすることに応じて新しいサウンドを生み出すことができます（このチュートリアルの後半でみていきます）。Sonic Piのシンセは、パワフルで表現力に富んでいて、試しながら演奏したり、楽しめるはずです。最初に、ひとまずここでシンセを使うために、選び方を学んでみましょう。

## 賑やかなsawとprophet

面白い音は、*ノコギリ（saw）波*です。試してみましょう。

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

他の音*prophet*を試してみましょう。

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

2つを一緒にしたらどうでしょう。一方のあとに、もう一方を。

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
```

（連続する `play`の間にスリープを入れないことで）同時に複数のサウンドが鳴ります：

```
use_synth :tb303
play 38
use_synth :dsaw
play 50
use_synth :prophet
play 57
```

`use_synth`コマンドは、下の`play`にだけ影響していることに注意してください。大きなスイッチのようなものだと考えてください。指定したどんなシンセでも、新しい`play`へ命令として演奏されます。`use_synth`で新しいシンセにスイッチすることができます。


## シンセを見つける

Sonic Piにあるシンセを確認するには、このヘルプ画面の下部にあるメニューのシンセ・オプション確認してください（ExamplesとFxの間）。20種類以上あります。その中から私のお気に入りをいくつか紹介します：

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

では、*音楽の中でシンセを切り替えて*遊んでみてください。音楽の異なるセクションに違うシンセを使うように、シンセを組み合わせて新しい音を作って楽しんでください。
