1.2 De Interface Verkennen

# De Interface van Sonic Pi

Sonic Pi heeft een zeer eenvoudige interface om muziek te coderen. Laten we even de tijd nemen deze te verkennen.

![Sonic Pi Interface](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Afspeel knoppen
* *B* - Editor aanpassen
* *C* - Info en Hulp
* *D* - Code Editor
* *E* - Paneel Voorkeursinstellingen
* *F* - Log Venster
* *G* - Hulp-Systeem
* *H* - Scope Venster
* *I* - Indicatie Venster

## A. Afspeel knoppen

Deze roze knoppen zijn de belangrijkste bedieningselementen voor het starten en stoppen van het geluid. Er is de *Afspelen* knop om de code in de editor af te spelen, *Stop* om alle actieve code te stoppen, *Opslaan* om de code naar een extern bestand op te slaan en *Opnemen* om een opname (WAV-bestand) te maken van het afspelende geluid.

## B. Werking van de Editor

Deze oranje knoppen maken het mogelijk om de code editor aan te passen. De *Schaal +* and *Schaal -* knoppen vergroten of verkleinen de tekst.

## C. Info en Hulp

Deze blauwe knoppen geven je toegang tot hulp-, informatie- en voorkeursinstellingen. De *Info* knop opent het venster dat informatie over Sonic Pi zelf bevat - het kernteam, de geschiedenis, de medewerkers en ook de Sonic Pi "gemeenschap". De *Hulp* knop schakelt naar het hulp-systeem (*G*) en de *Voorkeuren* knop schakelt naar het voorkeur-venster waarmee je een aantal fundamentele systeemparameters kan instellen.

## D. Code Editor

Dit is het gebied waarin je jouw code schrijft en muziek componeert/uitvoert. Het is een eenvoudige tekst-editor, waarin je code kan schrijven, verwijderen, knippen en plakken, enz. Denk aan een zeer eenvoudige versie van Word of Google Docs. De editor zal de kleur van woorden automatisch aanpassen op basis van hun betekenis in de code. Dit lijkt misschien eerst wat vreemd, maar je zal dit snel heel nuttig vinden. Bijvoorbeeld als het woord blauw is, dan weet je dat het om een getal gaat.

## E. Voorkeursinstellingen Paneel

Sonic Pi ondersteunt een aantal instellingen die toegankelijk zijn door het in-/uitschakelen van de knop *Voorkeuren* in de Info en Hulp knoppen-set. Dit zal het Paneel Voorkeursinstellingen, met daarin een aantal regelbare opties, tonen of verbergen. Voorbeelden zijn: het brengen van stereo naar mono, stereo omkeren, de detaillering van het log en ook een volumeregelaar en audio keuze voor de Raspberry Pi.

## F. Log Venster

Wanneer je je code uitvoert, zal informatie over wat het programma doet, getoond worden in een soort logboek. Je zult gewoonlijk een berichtje zien, voor elk geluid dat je maakt, met de exacte tijd dat het geluid werd geactiveerd. Dit is zeer handig om fouten in je code op te kunnen sporen en om te kunnen begrijpen wat je code doet.

## G. Hulp Systeem

Eén van de belangrijkste onderdelen van de Sonic Pi-interface is het hulp-systeem dat wordt weergegeven aan de onderkant van het venster. Dit kan worden getoond of verborgen door op de blauwe knop *Hulp* te klikken. Het hulp-systeem bevat hulp en informatie over alle aspecten van Sonic Pi, inclusief deze handleiding, een lijst van beschikbare synths, samples, voorbeelden, effecten en een volledige lijst van alle functies die Sonic Pi biedt voor het coderen van muziek.

## H. Scope Venster

In het scope venster zie je het geluid dat je hoort. Bijvoorbeeld dat een zaagtand-golf er ook uit ziet als een zaag en dat onze basis "beep"-toon een mooie golvende sinus-golf is. Je ziet ook duidelijk het verschil tussen luide en zachte geluiden door hun grootte. Er zijn 3 verschillende scopes beschikbaar, de standaard (default) is een gecombineerde scope voor het linker en rechter kanaal, een stereo variant die voor elk kanaal een aparte scope laat zien. En tenslotte is er een Lissajousfiguur scope die de fase relatie tussen het linker- en rechter-kanaal weergeven en je in staat stelt, mooie figuren te tekenen met geluid (https://nl.wikipedia.org/wiki/Lissajousfiguur).

## I. Indicatie Venster

Alle interne en externe events (`cues` in Sonic Pi) worden automatisch gelogd in het Indicatie Venster (`Cue` Viewer). Indien bijvoorbeeld een MIDI controller is aangesloten en een knop is ingedrukt, zal een new event zichtbaar zijn met de naam van de controller en de ingedrukte knop. Zodra je de basis van het produceren van geluiden beheerst, kun je secties van geluiden afspelen gebaseerd op dit soort events. Een `Cue`-event is een indicatie dat er iets gebeurd is. Wanneer er bijvoorbeeld een live loop loopt gaat, zal een `Cue`-event zichtbaar zijn in het Indicatie Venster. Externe events zoals MIDI berichten van verbonden apparatuur en OSC berichten van andere computers en programma's worden hier eveneens weergegeven. Het is ook mogelijk om direct `Cue` events te genereren middels de `cue` functie. Alles wat zichtbaar is in het Indicatie Venster kan gebruikt worden om een verandering te signaleren (trigger). Meer details hierover vind je in sectie 10 en 12 van deze handleiding.
