2.1 Twoje pierwsze dźwięki

# Twoje pierwsze dźwięki

Spójrz na poniższy kod:

```
play 70
```

To jest miejsce, w którym wszystko się zaczyna. Śmiało, skopiuj powyższy kod i wklej go do edytora kodu na górze aplikacji (duża biała przestrzeń tuż pod przyciskiem *Run*). Kiedy już to zrobisz, naciśnij przycisk Run...

## Bip!

A teraz naciśnij przycisk jeszcze raz. I jeszcze raz. *I jeszcze raz...*

Łał, szaleństwo. Jestem pewien, że możesz tak przez cały dzień. Ale poczekaj. Zanim zatracisz się w pętli nieskończonych bipów, spróbuj zmienić liczbę:

```
play 75
```

Słyszysz różnicę? Teraz spróbuj mniejszej liczby:

```
play 60
```

Zatem, mniejsze liczby stworzą niższe dźwięki, a większe liczby stworzą wyższe dźwięki. Jak w fortepianie - klawisze po lewej stronie grają niższe nuty, a klawisze po prawej grają wyższe nuty.

Wychodzi na to, że C w czwartej oktawie (C w notacji angielskiej) jest zidentyfikowane jako numer 60. A więc `play 60` zagra C z czwartej oktawy. Żeby zagrać następny spod następnego klawisza po prawej, musisz dodać 1 do 60, wpisując `play 61`, co w tym przypadku oznacza czarny klawisz Cis. Żeby zagrać D, czyli kolejny klawisz na prawo, napisz `play 62`.

*Nie przejmuj się*, jeśli nic z tego nie rozumiesz - ja również nie rozumiałem, gdy zaczynałem, dokładnie jak Ty teraz. Wszystko, co się teraz liczy, to to, że wiesz już, że *małe liczby generują dźwięki o niskim brzmieniu*, a *duże liczby generują dźwięki o wyższym brzmieniu*.

## Akordy

Zagranie nuty jest całkiem fajne, ale zagranie kilku jednocześnie może być jeszcze fajniejsze. Spróbuj:

```
play 72
play 75
play 79
```

Super! Zauważ, że kiedy napiszesz kilka razy komendę `play`, wszystkie dźwięki zagrają w tym samym momencie. Teraz spróbuj sam - które z nich brzmią dobrze razem? Które brzmią okropnie? Eksperymentuj, odkrywaj i przekonaj się na własnej skórze.

## Melodia

Granie nut i akordów jest fajne - a co powiesz na zagranie melodii? Co, jeśli chciałbyś zagrać jedną nutę po drugiej, a nie obie w tym samym czasie? Nic prostszego, wystarczy, że odczekasz chwilę pomiędzy zagraniem poszczególnych nut. Możesz to zrobić, używając polecenia `sleep`:

```
play 72
sleep 1
play 75
sleep 1
play 79
```

Cudownie, właśnie stworzyłeś małe arpeggio. No dobrze, ale co oznacza liczba `1` w poleceniu `sleep 1`? Oznacza ona *długość trwania odstępu pomiędzy nutami*. Zasadniczo oznacza to odstęp o długości jednego uderzenia, ale póki co możesz myśleć o tym jako o przerwie trwającej jedną sekundę. Co powinniśmy w takim razie zrobić, jeśli chcielibyśmy trochę przyśpieszyć nasze arpeggio? Należy użyć "krótszych" wartości dla polecenia sleep. Weźmy na przykład połowę, czyli wartość `0.5`:

```
play 72
sleep 0.5
play 75
sleep 0.5
play 79
```

Zauważ, że arpeggio gra teraz szybciej. Teraz Twoja kolej, pobaw się tym kawałkiem kodu, zmieniając czasy według własnego uznania oraz używając różnych nut.

Jest jeszcze jedna rzecz, którą warto wypróbować. Spróbuj użyć tych, które są "pomiędzy" całymi nutami, np. `play 52.3`, `play 52.63`. Nie ma absolutnie żadnej konieczności, abyś kurczowo trzymał się standardowych, pełnych nut. Pokombinuj z różnymi wartościami i baw się dobrze.


## Tradycyjne Nazwy Nut

Osoby, które aktualnie znają już trochę notację muzyczną (nie przejmuj się, jeśli jej nie znasz - nie potrzebujesz tego, żeby móc się dobrze bawić), być może będą preferować pisanie melodii przy wykorzystaniu standardowych nazw nut, np. C lub F# (Fis) zamiast liczb. Sonic Pi na to pozwala. Nic nie stoi na przeszkodzie, abyś napisał i uruchomił taki kod:

```
play :C
sleep 0.5
play :D
sleep 0.5
play :E
```

Pamiętaj tylko, żeby umieścić dwukropek `:` tuż przed nazwą Twojej nuty, tak że zmieni ona kolor na różowy. Możesz również zdefiniować oktawę, umieszczając odpowiednią liczbę tuż po jej nazwie:

```
play :C3
sleep 0.5
play :D3
sleep 0.5
play :E4
```

Jeśli chcesz sprawić, aby nuta brzmiała o pół tonu wyżej (uzyskanie dźwięku fis), dodaj `s` tuż za Twoją nutą, np. `play :Fs3`. Analogicznie - jeśli chcesz obniżyć jej dźwięk o połowę (uzyskanie dźwięku mol), dodaj na końcu niej `b`, np. `play :Eb3`.

There's also a handy shortcut for a rest (a musical way of saying not to play anything instead of a note) using `:r`, `:rest` or `nil`.

A teraz *zaszalej* i spróbuj stworzyć swoje własne melodie.
