7.3 Opções deslizantes

# Opções deslizantes

Enquanto exploravas as opções dos synth e efeitos, poderás ter reparado que existe um número de opções terminando com `_slide`. Podes até ter tentado as chamar e não veres nenhum efeito. Isto é porque eles não são parâmetros normais, eles são opções especiais que apenas funcionam quando controlares synths como introduzido na secção anterior.

Considera o exemplo seguinte:

```
s = play 60, release: 5
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Aqui, podes ouvir o pitch do synth mudar imediatamente a cada chamada a `control`. No entanto, podemos querer que o pitch deslize entre as mudanças. Ao controlarmos o parâmetro `note:`, para adicionar o deslizamento, necessitamos de definir o parâmetros `note_slide` no synth:

```
s = play 60, release: 5, note_slide: 1
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Agora podemos ouvir as notas a serem dobradas entre as chamadas a `control`. Soa bem ,não soa? Podes acelerar o deslizamento usando um tempo mais curto como `note_slide: 0.2` ou abrandar usando um tempo mais longo.

Cada parâmetro pode ser controlado como um parâmetro `_slide` correspondente para tu brincares com ele.

## Deslizamento é permanente

Uma vez definido um parâmetro `_slide` num synth em execução, ele será lembrado e usado cada vez que deslizes o parâmetro correspondente. Para parar o deslizamento, terás que definir o valor de `_slide` a 0 antes da próxima chamada a `control`.

## Deslizando opções de efeitos

É também possível deslizar opções de efeitos:

```
with_fx :wobble, phase: 1, phase_slide: 5 do |e|
  use_synth :dsaw
  play 50, release: 5
  control e, phase: 0.025
end
```

Agora diverte-te deslizando coisas para suavizar transições e controlo do fluxo...
