9.2 Live Loops

# Live Loops

Ok, esta secção do tutorial é uma verdadeira gema. Se apenas leres uma secção, deveria ser esta. Se leste as secções anteriores sobre os fundamentos de codificar ao vivo, `live_loop` é uma simples maneira de fazer isso mas sem ter que escrever muito código.

Se não leste a secção anterior, `live_loop`é a melhor maneira de improvisar com o Sonic Pi.

Vamos tocar. Escreve o seguinte num buffer novo:

```
live_loop :foo do
  play 60
  sleep 1
end
```

Agora prime o botão Run. Ouviras o beep básico. Nada de especial por aqui. No entanto, não primas Stop ainda. Muda o `60` para `65` e clica no Run outra vez.

WOW! Mudou *automaticamente* sem perder a batida. Isto é Live coding.

Porque não mudar para algo mais parecido com baixo? Actualiza o teu código enquanto corre:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8
  sleep 8
end
```

Depois prime Run.

Vamos fazer mudanças ao cutoff:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Prime o botão Run outra vez.

Adiciona bateria:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Muda a nota de `e1` para `c1`:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :c1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Agora pára de me ouvir tocar e brinca tu próprio! Diverte-te!
