8.2 Acorduri

# Acorduri

Sonic Pi ofera suport pentru denumirile standard ale acordurilor. Incearca singur:

```
play chord(:E3, :minor)
```

Asa mai merge. Acum arata mai bine decat o lista bruta (si e mai usor de citit pentru altii). Ce alte acorduri mai suporta Sonic Pi? Ei bine, *o multime*. Incearca-le pe acestea:

* `chord(:E3, :m7)`
* `chord(:E3, :minor)`
* `chord(:E3, :dim7)`
* `chord(:E3, :dom7)`

## Arpegii

Putem transforma usor acordurile in arpegii cu functia 'play_pattern':

```
play_pattern chord(:E3, :m7)
```

Ok, that's not so fun - it played it really slowly. `play_pattern` will play each note in the list with a call to `sleep 1` after each call to `play`. We can use another function `play_pattern_timed` to specify our own timings and speed things up:

```
play_pattern_timed chord(:E3, :m7), 0.25
```

Putem sa ii transmitem o lista de intervale de timp care va fi citita circular (dupa ultima valoare o reia de la inceput):

```
play_pattern_timed chord(:E3, :m13), [0.25, 0.5]
```

Aceasta linie este echivalenta cu:

```
play 52, sustain: 0.25
sleep 0.25
play 55, sustain: 0.5
sleep 0.5
play 59, sustain: 0.25
sleep 0.25
play 62, sustain: 0.5
sleep 0.5
play 66, sustain: 0.25
sleep 0.25
play 69, sustain: 0.5
sleep 0.5
play 73, sustain: 0.25
sleep 0.25
```

Cum preferi sa scrii?

Note that `play_pattern` and `play_pattern_timed` alter the sustain of the notes to fill the times. You can remove this behavior by setting the `sustain:` opt to `0`:

```
play_pattern_timed chord(:E3, :m13), [0.25, 0.5], sustain: 0
```
