7.1 Контроль выполняющихся синтов

# Управление играющим синтезатором

Раньше мы изучали только как включать звуки и добавлять эффекты. Однако, в Sonic Pi есть возможность управлять воспроизводимыми звуками. Этого можно достичь, сохранив ссылку на синт в переменной:

```
s = play 60, release: 5
```

В этом примере мы создали локальную переменную среды выполнения `s`, которая представляет собой синт, играющий ноту 60. Обратите внимание, что она локальна для *текущего контекста* - нельзя получить к ней доступ из других контекстов, таких как функции.

После того, как у нас появилась `s`, мы можем управлять ей с помощью функции `control`:

```
s = play 60, release: 5
sleep 0.5
control s, note: 65
sleep 0.5
control s, note: 67
sleep 3
control s, note: 72
```

Заметьте, что мы запускаем не четыре разных синта, а один и просто изменяем высоту звука в то время, как он продолжает играть.

Можно передавать функции `control` любые из стандартных настроек, то есть доступен контроль над такими параметрами, как `amp:`, `cutoff:` или `pan:`.

## Неконтролируемые настройки

Некоторые регулировки нельзя менять после включения синта. Это относится ко всем параметрам ADSR-огибающей. Из документации в справочной системе можно узнать какие параметры разрешено менять, а какие нет. Если документация говорит *Нельзя изменять после установки*, это значит, что после запуска синта настройке нельзя задавать новое значение.
