1.2 Arayüzü Keşfetme

# Sonic Pi Arayüzü

Sonic Pi müzik kodlamak için çok basit bir arayüze sahiptir. Haydi bu arayüzü keşfetmek için biraz vakit ayıralım.

![Sonic Pi Arayüzü](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Oynatma Kontrolleri
* *B* - Düzenleme Kontrolleri
* *C* - Bilgi ve Yardım
* *D* - Kod Düzenleyici
* *E* - Tercihler Paneli
* *F* - Günlük Görüntüleyici
* *G* - Yardım Sistemi
* *H* - Kapsam Görüntüleyici
* *I* - İpucu Görüntüleyici

## A. Oynatma Kontrolleri

Bu pembe butonlar sesleri başlatmak ve durdurmak için ana kontrollerdir. Düzenleyicide sesleri çalmak için *Run* butonu, durdurmak için *Stop* butonu, kodu harici bir dosyaya kaydetmek için *Save* butonu ve çalan sesin bir kaydını oluşturmak için (bir WAV dosyası) *Record* butonu yer alıyor.

## B. Düzenleyici Kontrolleri

Bu turuncu butonlar kod düzenleyiciyi değiştirmenize olanak sağlar. *Size+* ve *Size-* butonları metni daha büyük veya daha küçük yapmanıza olanak sağlar.

## C. Bilgi ve Yardım

Bu mavi butonlar bilgi, yardım ve tercihlere erişmenizi sağlar. *Info* butonu Sonic Pi ile ilgili bilgileri içeren - çekirdek ekip, tarihçe, katkı sağlayanlar ve topluluk - pencereyi açar. *Help* butonu yardım sistemine (*G*) geçmenizi ve *Prefs* butonu bazı sistem değişkenlerini kontrol etmenizi sağlayan tercihler penceresine geçmenizi sağlar.

## D. Kod Düzenleyici

Bu alan kodunuzu yazacağınız ve müzik düzenleme veya çalma alanıdır. Burası kodunuzu yazabileceğiniz, silebileceğiniz, kesme ve kopyalama işlemlerini yapabileceğiniz basit bir metin düzenleyicidir. Bunu Word veya Google Docs uygulamalarının basit bir versiyonu olarak düşünün. Düzenleyici sözcükleri kod içerisindeki anlamlarına göre otomatik olarak renklendirecektir. Bu, ilk bakışta garip görünse de kısa sürede çok faydalı olduğunu göreceksiniz. Örneğin, bir kelime eğer maviyse bunun sayı olduğunu anlayacaksınız.

## E. Tercihler Paneli

Sonic Pi Bilgi ve Yardım düğme grubunda yer alan *prefs* düğmesi ile geçiş yapabileceğiniz birtakım kişiselleştirme tercihleri sunar. Bu Tercihler Panelinin görünürlüğünü değiştirerek birtakım değiştirebilir seçenekleri gösterir. Örnek olarak, tekil biçimi zorlamak, stereoyu ters çevirmek, günlük çıktılarının ayrıntı seviyesini değiştirmek ve Raspberry Pi için bir ses kaydırıcı ve ses seçici.

## F. Günlük Görüntüleyici

Kodunuzu çalıştırdığınızda, programın ne yaptığı günlük görüntüleyicide görüntülenir. Varsayılan olarak, yarattığınız her ses için ses tetiklendiği anda bir mesaj göreceksiniz. Bu kodunuzdaki hataları ayıklamanız ve kodunuzun ne yaptığını anlamanız için çok faydalı olacaktır.

## G. Yardım Sistemi

Sonic Pi arayüzünün en önemli parçalarından biri de pencerenin alt kısmında yer alan yardım sistemidir. Bu kısım mavi *Help* butonuna tıklayarak açılıp kapatılabilir. Yardım sistemi; bu rehberi, kullanılabilir synth listesini, örnekleri, FX ve Sonic Pi'ın müzik kodlamak için sağladığı tüm fonksiyonların listesini de içeren Sonic Pi için tüm yardım ve bilgi sistemini içerir.

## H. Kapsam Görüntüleyici

Kapsam görüntüleyici duyduğunuz sesi görmenizi sağlar. Testere dişlisi dalgasının tıpkı bir testere gibi ve temel bip sesinin ise kavisli bir sinüs dalgası şeklinde olduğunu kolayca görebilirsiniz. Bunun yanında yüksek ve düşük sesleri çizgilerin yüksekliğinden ayırt edebilirsiniz. 3 tip kapsam bulunmaktadır: varsayılan sol ve sağ kanallar için birleştirilmiş kapsam, bir diğeri ise her kanal için ayrı bir kapsam çizen stereo kapsamdır, son olarak ise sağ ve sol kanal arasındaki faz ilişkisini gösteren ve müzikle harika resimler elde etmenizi sağlayan Lissajous eğrisi kapsamıdır (https://en.wikipedia.org/wiki/Lissajous_curve).

## I. İpucu Görüntüleyici

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
